#include <iostream>
#include <vector>
#include <algorithm>

using pos_t = uint64_t;
constexpr int board_size = 7;

pos_t rot1(pos_t n) {
    pos_t ret = 0;
    for( int x = 0; x < board_size; ++x ) {
        for( int y = 0; y < board_size; ++y ) {
            ret |= n&(static_cast<pos_t>(1)<<(x*board_size+y))?static_cast<pos_t>(1)<<(y*board_size+(board_size-1-x)):0;
        }
    }
    return ret;
}

pos_t rot2(pos_t n) { return rot1(rot1(n)); }
pos_t rot3(pos_t n) { return rot2(rot1(n)); }


pos_t mirror(pos_t n) {
    pos_t ret = 0;
    for( int x = 0; x < board_size; ++x ) {
        for( int y = 0; y < board_size; ++y ) {
            ret |= n&(static_cast<pos_t>(1)<<(x*board_size+y))?static_cast<pos_t>(1)<<(x*board_size+(board_size-1-y)):0;
        }
    }
    return ret;
}

template<class T>
constexpr T min( T a, T b ) { return a < b ? a : b; }
template<class T, typename... Args>
constexpr T min( T a, T b, Args... args ) { return min( a, min( b, args... ) ); }

void display( pos_t board ) {
    int num = 0;
    for( int x = 0; x < board_size; ++x ) {
        for( int y = 0; y < board_size; ++y ) {
            if( board & static_cast<pos_t>(1)<<(x*board_size+y) ) {
                std::cout << "Z";
                ++num;
            } else {
                std::cout << "@";
            }
        }
        std::cout << std::endl;
    }
    std::cout << "--" << num << std::endl;
}

int main() {
    do {
        pos_t b;
        std::cin >> b;
        display( b );
    } while(std::cin);
}

